<template>
  <el-form label="Login" @submit.prevent="login">
    <el-form-item>
      <el-input class="w-100 mb-3" type="text" placeholder="Username" v-model="user.email"></el-input>
      <el-input class="w-100 mb-3" type="password" placeholder="Password" v-model="user.password"></el-input>
      <el-button class="w-100 mb-3" @click="login">Log in</el-button>
    </el-form-item>
  </el-form>
</template>

<script>
    import auth from '../controllers/requests/auth'

    export default {
        name: "Login",
        data() {
            return {
                user: {
                    email: '',
                    password: ''
                },
                formErrors: [],
                loading: false
            }
        },
        methods: {
            login() {
                this.formErrors = []
                this.loading = true
                auth.loginUser(this.user)
                    .then(() => {
                        this.$root.$emit("changedUserLogState");
                        this.$router.push({path: '/'});
                        this.$notify({
                            title: 'Logged in',
                            message: 'User successfully logged in.',
                            type: "success"
                        });
                    })
                    .catch(e => {
                        let msg

                        if (e.response.status === 401) {
                            msg = 'User Not Found'
                        }

                        if (msg) {
                            this.formErrors.push(msg)
                        }
                    })
                    .finally(() => {
                        this.loading = false
                    })
            }
        }
    }
</script>

<style scoped>

</style>
